#!/bin/sh

cd `dirname $0`

. ./commun-minpopd

[ -f /etc/shadow ] && FicPass=/etc/shadow || FicPass=/etc/passwd

Retr ()
{
    NumeroMessage="$1"
    
    i=0
    OK=""
    
    (sed "s/	/\\\\\\\t/" < $MAILBOX_ROOT/$User | while read ligne
    do
        if echo "$ligne" | grep "^From " > /dev/null
        then
            i=`expr $i + 1`
            [ $NumeroMessage -eq $i ] || continue
            while read ligne2
            do
                if echo "$ligne2" | grep "^From " > /dev/null
                then
                    OK="y"
                    break
                else
                    echo -e "$ligne2"
                fi
            done
        fi
    
        [ "$OK" = "y" ] && break
    done)
    echo "."
}

Dele ()
{
    NumeroMessage="$1"
    
    i=0
    OK=""
    
    (sed "s/	/\\\\\\\t/" < $MAILBOX_ROOT/$User | while read ligne
    do
        if echo "$ligne" | grep "^From " > /dev/null || [ "$OK" = "y" ]
        then
            i=`expr $i + 1`
    
    #
    # Si on est sur le message a effacer, il ne faut rien ecrire
    #
    
            if [ $NumeroMessage -eq $i ]
            then
                while read ligne2
                do
    
    #
    # Si on arrive a la fin du message courant, retour au debut
    #
    
                    echo "$ligne2" | grep "^From " > /dev/null && OK="y" && break
                done
    
    #
    # Sinon il faut ecrire chaque ligne du message courant
    #
    
            else
                [ -n "$ligne2" ] && echo -e "$ligne2"
                echo -e "$ligne"
                while read ligne2
                do
    
    #
    # Si on arrive a la fin du message courant, retour au debut
    #
    
                    if echo "$ligne2" | grep "^From " > /dev/null
                    then
                        OK="y"
                        break
                    else
                        echo -e "$ligne2"
                    fi
                done
            fi
        fi
    done) > $MAILBOX_ROOT/$User.old
    mv -f $MAILBOX_ROOT/$User.old $MAILBOX_ROOT/$User
    echo "+OK Message $NumeroMessage has been deleted."
}

Stat ()
{
    if [ -f $MAILBOX_ROOT/$User ]
    then
        NombreMessages=`su $User -c 'grep -c "^From " $MAILBOX_ROOT/$User'`
        set -- `ls -l $MAILBOX_ROOT/$User`
        TailleBoite=$5
    else
        exit 1
    fi
}

echo "+OK minpopd at `hostname --fqdn` starting."

while read ligne
do
    set -- $ligne
    Cmd=`echo $1 | tr [a-z] [A-Z]`
    case "$Cmd" in
        USER) User=$2 ; echo "+OK Password required for $User." ;;
        PASS) Pass=$2
              PassCrypte=`grep $User $FicPass | cut -d: -f2`
              Pass2=`mkpasswd $Pass $PassCrypte`
              [ "$PassCrypte" != "$Pass2" ] && echo "-ERR Wrong password" && exit 1
              export MAILBOX_ROOT User
              Stat
              echo "+OK $User has $NombreMessages messages ($TailleBoite octets)."
              ;;
        STAT) Stat ; echo "+OK $NombreMessages $TailleBoite" ;;
        RETR) Retr $2 ;;
        DELE) Dele $2 ;;
        QUIT) echo "+OK Pop server at `hostname --fqdn` signing off." ; exit 0 ;;
        *) echo "-ERR Unknown command: \"$@\"."
    esac
done
